class Scene_Intro
  def main
    Graphics.transition(0)
    check_update
    @eventscene = IntroEventScene.new
    @eventscene.main
    Graphics.freeze
  end
end

$eshu_downloading_result = 0
def check_update
  return if $DEBUG || os_family != "windows"
  if Settings::ESHU_GAME_NAME == ""
    raise "未在Config中配置Settings::ESHU_GAME_NAME"
    return
  end
  check_url = "http://api.pokefans.xyz/ess/check_update/?name=" + Settings::ESHU_GAME_NAME + "&version=" + (Settings::ESHU_GAME_VERSION).to_s
  result = pbDownloadToString(check_url)
  if nil_or_empty?(result)
    # 检查更新失败
    pbMessage(_INTL("<ac>\\l[2]当前无法检测更新，\n建议您主动查看是否有最新版本游戏。"))
    return
  end
  data = (eval(result) rescue nil)
  if !data
    raise "hash转换出错"
    return
  end
  # 检查更新成功
  status         = data["status"]
  content        = data["content"]
  if status != 200
    raise content
    return
  end
  server_version = data["server_version"]
  min_version    = data["min_version"]
  download_url   = data["url"]
  # 服务器版本号大于本地版本号，说明有更新
  if server_version > Settings::ESHU_GAME_VERSION
    line = [9, content.count("\n") + 2].min
    pbMessage(_INTL("\\l[{1}]当前非最新版游戏，检测到更新内容：\n{2}", line, content))
    # 服务器要求最低版本号大于本地版本号，说明是大更新，不允许热更新
    if min_version > Settings::ESHU_GAME_VERSION
      if !Settings::ESHU_ALLOW_IGNORE ||
         !pbConfirmMessage("是否要不更新直接游玩当前版本？")
        exit
      end
    else  # 热更新
      Thread.new {
        filename = download_url[download_url.rindex("/") + 1, download_url.length - 1]
        filetype = download_url[download_url.rindex(".") + 1, download_url.length - 1]
        if pbDownloadToFile(download_url, filename)    # 下载成功
          if filetype == "zip"
            if system("start /min cmd.exe /c %0 & tar -xzvf " + filename)   # 解压成功
              File.delete(filename)   # 解压成功后删除压缩包
              $eshu_downloading_result = 1
            else  # 解压失败
              $eshu_downloading_result = -2
            end
          else
            $eshu_downloading_result = 1
          end
        else    # 下载失败
          $eshu_downloading_result = -1
        end
      }
      scene = ESHU_Scene.new
      screen = ESHU_Screen.new(scene)
      screen.pbShowScreen
    end
  end
end

def os_family
  os = "other"
  case RUBY_PLATFORM
  when /ix/i, /ux/i, /gnu/i,/sysv/i, /solaris/i,/sunos/i, /bsd/i  
    os = "unix"
  when /win/i, /ming/i
    os = "windows"
  end
  return os
end