class ESHU_Scene
  
  def initialize
    @viewport   = Viewport.new(0, 0, Graphics.width, Graphics.height)
    @viewport.z = 99999
    @sprites    = {}
    @sprites["bg"]        = AnimatedPlane.new(@viewport)
    bitmap = pbResolveBitmap("Graphics/UI/ESHU/bg_" + ($player&.female? ? "f" : "m"))
    @sprites["bg"].setBitmap(bitmap)
    #@sprites["bg"].x      = 0
    #@sprites["bg"].y      = 0
    @sprites["bg"].z      = @viewport.z
    
    pkmns       = Settings::ESHU_POKEMON * 2
    @pkmn_x     = [ 16, 160, 304, 448, 592, 736]
    @pkmn_x.each_with_index do |x, i|
      @sprites["pkmn#{i}"] = IconSprite.new(x, 96)
      @sprites["pkmn#{i}"].setBitmap("Graphics/Pokemon/Front/#{pkmns[i]}")
      @sprites["pkmn#{i}"].z = @viewport.z + 1
    end
    
  end
  
  def pbStartScreen
    pbBGMPlay("ESHU_Downloading", 30)
    # 信息文字
    @sprites["text"]    = BitmapSprite.new(Graphics.width, Graphics.height, @viewport)
    @sprites["text"].x  = 0
    @sprites["text"].y  = 0
    @sprites["text"].z  = @viewport.z + 1
    fontColor           = Color.new(248, 248, 248)
    shadowColor         = Color.new( 64,  64,  64)
    textpos             = []
    textpos.push([
      _INTL("正在自动下载热更新文件，"),
          Graphics.width/2, Graphics.height - 64, 2, fontColor, shadowColor, 1
    ])
    textpos.push([
      _INTL("耗时较长，请耐心等待。"),
          Graphics.width/2, Graphics.height - 32, 2, fontColor, shadowColor, 1
    ])
    pbSetSystemFont(@sprites["text"].bitmap)
    pbDrawTextPositions(@sprites["text"].bitmap, textpos)
    loop do
      Graphics.update
      Input.update
      @sprites["bg"].ox += 1
      @sprites["bg"].ox = 0 if @sprites["bg"].ox > 32
      should_reset = false
      @pkmn_x.size.times do |i|
        if @sprites["pkmn#{i}"].ox >= 144 * 3
          should_reset = true
          break
        end
        @sprites["pkmn#{i}"].ox += 1
      end
      if should_reset
        @pkmn_x.size.times do |i|
          @sprites["pkmn#{i}"].ox = 0
        end
      end
      next if $eshu_downloading_result == 0
      @sprites["text"].bitmap.clear
      textpos = []
      if $eshu_downloading_result == -2
        textpos.push([
          _INTL("更新文件下载成功但解压失败，请手动解压。"), Graphics.width/2,
                Graphics.height - 48, 2, fontColor, shadowColor, 1
        ])
        pbDrawTextPositions(@sprites["text"].bitmap, textpos)
        return
      elsif $eshu_downloading_result == -1
        textpos.push([
          _INTL("更新文件下载失败，请稍后重试。"), Graphics.width/2,
                Graphics.height - 48, 2, fontColor, shadowColor, 1
        ])
        pbDrawTextPositions(@sprites["text"].bitmap, textpos)
        return
      elsif $eshu_downloading_result == 1
        textpos.push([
          _INTL("更新已完成，即将尝试重启游戏。"), Graphics.width / 2,
                Graphics.height - 48, 2, fontColor, shadowColor, 1
        ])
        pbDrawTextPositions(@sprites["text"].bitmap, textpos)
        break
      end
    end
    pbSEPlay("GUI naming confirm")
    pbWait(is_21 ? 0.5 : 60)
    Thread.new { system("Game") } #重启游戏
    exit
  end
  
  def pbEndScreen
    pbDisposeSpriteHash(@sprites)
    @viewport.dispose
  end
  
  def is_21
    return (Essentials::VERSION).to_f >= 21
  end
  
end


class ESHU_Screen
  def initialize(scene)
    @scene = scene
  end

  def pbShowScreen
    @scene.pbStartScreen
    @scene.pbEndScreen
  end
end